<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 7.8.5: Storage Management</title>
<link href="sx10k.html" rev=precedes>
<link href="sx10m.html" rel=precedes>
<link href="sx10.html" rev=subdocument>
</head>
<body>
<H2>section 7.8.5: Storage Management</H2>

<p>The important thing to know
about <TT>malloc</TT> and <TT>free</TT> and friends
is to be careful when calling them.
It is easy to abuse them,
either by using more space than you ask for
(that is, writing beyond the ends of an allocated block)
or by continuing to use a pointer after the memory it points to has been freed
(perhaps because you had several pointers to the same block of memory,
and you forgot that when you freed one pointer
they all became invalid).
<TT>malloc</TT>-related bugs can be difficult and frustrating to track down,
so it's good to use programming practices
which help to assure that the bugs don't happen in the first place.
(One such practice is to make sure that pointer variables are set to 
<TT>NULL</TT> when they don't point anywhere,
and to occasionally check pointer values--for instance at
entry to an important pointer-using function--to make sure 
that they're not <TT>NULL</TT>.)
</p><p>As we mentioned on page 142 in section 6.5,
it is no longer necessary
(that is, in ANSI C)
to cast <TT>malloc</TT>'s value to the appropriate type,
though it doesn't hurt
to do so.
</p><hr>
<p>
Read sequentially:
<a href="sx10k.html" rev=precedes>prev</a>
<a href="sx10m.html" rel=precedes>next</a>
<a href="sx10.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
